// GRANDMASTER! from marvel comics. One of the Elders of the Universe, has the power to to resurrect dead beings.
// Created 5/18/2003
// Hero Originally named Zeus, changed since powers did not fit.

/* CVARS - copy and paste to shconfig.cfg

//Grandmaster
gmaster_level 9
gmaster_cooldown 600		//# of seconds for Grandmaster cooldown

*/

#include <amxmodx>
#include <cstrike>
#include <shero>

// GLOBAL VARIABLES
new g_heroName[]="Grandmaster"
new g_heroID
new bool:g_hasGMasterPower[SH_MAXSLOTS+1]
//----------------------------------------------------------------------------------------------
public plugin_init()
{
	// Plugin Info
	register_plugin("SUPERHERO Grandmaster", "2.0", "{HOJ} Batman/JTP10181")

	// DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
	register_cvar("gmaster_level", "9")
	register_cvar("gmaster_cooldown", "600")

	// FIRE THE EVENT TO CREATE THIS SUPERHERO!
	g_heroID = sh_create_hero(g_heroName)
	sh_hero_info(g_heroID, "Revive Dead", "Utilize cosmic life force to Revive a Dead Teammate")
	sh_hero_bind(g_heroID, false)
	sh_hero_level(g_heroID, get_cvar_num("gmaster_level"))

	// REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
	// DEATH
	register_event("DeathMsg", "gmaster_death", "a")
}
//----------------------------------------------------------------------------------------------
public plugin_precache()
{
	precache_sound("ambience/port_suckin1.wav")
}
//----------------------------------------------------------------------------------------------
public sh_hero_init(id, heroID, mode)
{
	if ( g_heroID == heroID )
		g_hasGMasterPower[id] = (mode != 0)
}
//----------------------------------------------------------------------------------------------
public sh_new_spawn(id)
{
	if ( !sh_server_info(SH_INROUND) )
		sh_uset(id, g_heroID, 0)
	else
		sh_uset(id, g_heroID, 1) // dead Grandmaster's loose their revive...
}
//----------------------------------------------------------------------------------------------
public gmaster_death()
{
	if ( !sh_server_info(SH_MODACTIVE) || !sh_server_info(SH_INROUND) )
		return

	new id = read_data(2)

	if ( !is_user_connected(id) || is_user_alive(id) )
		return

	new CsTeams:idTeam = cs_get_user_team(id)

	// Look for alive players with unused Grandmaster Powers on the same team
	for ( new i = 1; i <= SH_MAXSLOTS; i++ )
	{
		if ( i != id && is_user_alive(i) && g_hasGMasterPower[i] && !sh_ustatus(i, g_heroID) && idTeam == cs_get_user_team(i) )
		{
			// We got a Grandmaster character willing to raise the dead!
			new parm[2]
			parm[0] = id
			parm[1] = i
			set_task(1.0, "gmaster_respawn", 0, parm, 2)
		}
	}
}
//----------------------------------------------------------------------------------------------
public gmaster_respawn(parm[])
{
	new dead = parm[0]
	new gmaster = parm[1]

	if ( sh_ustatus(gmaster, g_heroID) || !sh_server_info(SH_INROUND) ) return
	if ( !is_user_connected(dead) || !is_user_connected(gmaster) ) return
	if ( !is_user_alive(gmaster) || is_user_alive(dead) ) return
	if ( cs_get_user_team(dead) != cs_get_user_team(gmaster) ) return

	sh_utimer(gmaster, g_heroID, get_cvar_float("gmaster_cooldown"))

	emit_sound(gmaster, CHAN_STATIC, "ambience/port_suckin1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)

	new gmasterName[32], deadName[32]
	get_user_name(gmaster, gmasterName, 31)
	get_user_name(dead, deadName, 31)
	client_print(0, print_chat, "[SH] %s used cosmic life force to Revive Dead Team Member %s!", gmasterName, deadName )

	// Double spawn prevents the no HUD glitch (hopefully)
	spawn(dead)
	spawn(dead)

	emit_sound(dead, CHAN_STATIC, "ambience/port_suckin1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)

	sh_Glow(dead, 255, 255, 0)

	set_task(3.0, "gmaster_unglow", dead)
	set_task(1.0, "gmaster_teamcheck", 0, parm, 2)
}
//----------------------------------------------------------------------------------------------
public gmaster_unglow(id)
{
	sh_Unglow(id)
}
//----------------------------------------------------------------------------------------------
public gmaster_teamcheck(parm[])
{
	new dead = parm[0]
	new gmaster = parm[1]

	if ( cs_get_user_team(dead) != cs_get_user_team(gmaster) )
	{
		client_print(dead, print_chat, "[SH] You changed teams and were Grandmaster Revived, now you shall die")
		user_kill(dead, 1)
		sh_uset(gmaster, g_heroID, 0)
	}
}
//----------------------------------------------------------------------------------------------