// HULK!

/* CVARS - copy and paste to shconfig.cfg

//Hulk
hulk_level 0
hulk_radius 1800		//Radius of people affected
hulk_cooldown 7		//# of seconds before Hulk can ReStun
hulk_stuntime 3		//# of seconds Hulk Stuns Everybody
hulk_stunspeed 70		//Speed of stunned players

*/

#include <amxmodx>
#include <engine>
#include <cstrike>
#include <shero>

// GLOBAL VARIABLES
new g_heroName[]="Hulk"
new g_heroID
new bool:g_hasHulk[SH_MAXSLOTS+1]

#define g_hulkSoundCount 3
new g_stompSound[g_hulkSoundCount][] = {
	"debris/bustconcrete1.wav",
	"debris/bustcrate1.wav",
	"debris/bustcrate3.wav"
}
//----------------------------------------------------------------------------------------------
public plugin_init()
{
	// Plugin Info
	register_plugin("SUPERHERO Hulk", "2.0", "{HOJ} Batman")

	// DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
	register_cvar("hulk_level", "0")
	register_cvar("hulk_radius", "1800")
	register_cvar("hulk_cooldown", "7")
	register_cvar("hulk_stuntime", "3")
	register_cvar("hulk_stunspeed", "70")

	// FIRE THE EVENT TO CREATE THIS SUPERHERO!
	g_heroID = sh_create_hero(g_heroName)
	sh_hero_info(g_heroID, "Power Stomp", "Immobilizes Self and Nearby Enemies")
	sh_hero_bind(g_heroID, true)
	sh_hero_level(g_heroID, get_cvar_num("hulk_level"))
}
//----------------------------------------------------------------------------------------------
public plugin_precache()
{
	// TBD - SOUNDS!
	for ( new x = 0; x < g_hulkSoundCount; x++ )
		precache_sound(g_stompSound[x])
}
//----------------------------------------------------------------------------------------------
public sh_hero_init(id, heroID, mode)
{
	if ( g_heroID == heroID )
		g_hasHulk[id] = (mode != 0)
}
//----------------------------------------------------------------------------------------------
public sh_new_spawn(id)
{
	sh_uset(id, g_heroID, 0)
}
//----------------------------------------------------------------------------------------------
// RESPOND TO KEYDOWN
public sh_hero_key(id, heroID, key)
{
	if ( g_heroID != heroID || key != SH_KEYDOWN ) return
	if ( !sh_server_info(SH_INROUND) ) return
	if ( !is_user_alive(id) || !g_hasHulk[id] ) return

	new Float:velocity[3]
	entity_get_vector(id, EV_VEC_velocity, velocity)

	// Hulk should technically be standing still to do this...  (i.e. no jump or air)
	// Let them know they already used their ultimate if they have
	if ( velocity[2] < -10.0 || velocity[2] > 10.0 || sh_ustatus(id, g_heroID) )
	{
		playSoundDenySelect(id)
		return
	}

	new hulkRadius = get_cvar_num("hulk_radius")
	new Float:hulkCooldown = get_cvar_float("hulk_cooldown")
	new Float:hulkStunTime = get_cvar_float("hulk_stuntime")
	new Float:hulkStunSpeed = get_cvar_float("hulk_stunspeed")
	new CsTeams:hulkTeam = cs_get_user_team(id)

	// OK Power stomp enemies closer than x distance
	new userOrigin[3]
	new victimOrigin[3]
	new distanceBetween

	sh_utimer(id, g_heroID, hulkCooldown)

	get_user_origin(id, userOrigin)

	for ( new i = 1; i <= SH_MAXSLOTS; i++ )
	{
		if ( (is_user_alive(i) && hulkTeam != cs_get_user_team(i)) || i == id )
		{
			get_user_origin(i, victimOrigin)
			distanceBetween = get_distance(userOrigin, victimOrigin)
			if ( distanceBetween < hulkRadius )
			{
				sh_screenshake(i, 14, 14, 14)
				sh_stunplayer(i, hulkStunTime, hulkStunSpeed)
			}
		}
	}

	// Dependent on the hulkStunTime - Set some Stomp Sounds
	new count = 0
	for ( new x = 0; x < 2 * hulkStunTime; x++ )
	{
		new parm[2]
		parm[0] = id
		parm[1] = count++

		if ( count >= g_hulkSoundCount )
			count = 0

		set_task( (x * 1.0) / 2.0, "stompSound", 0, parm, 2)
	}
}
//----------------------------------------------------------------------------------------------
public playSound(id, soundNbr)
{
	emit_sound(id, CHAN_STATIC, g_stompSound[soundNbr], 1.0, ATTN_NORM, 0, PITCH_HIGH)
}
//----------------------------------------------------------------------------------------------
public stompSound(parm[2])
{
	playSound(parm[0], parm[1])
}
//----------------------------------------------------------------------------------------------
public client_connect(id)
{
	g_hasHulk[id] = false
}
//----------------------------------------------------------------------------------------------