// XAVIER! - from the X-men, aka professor X.
// BASED ON SPACEDUDE'S NEW XTRAFUNMOD - FORGOT WHERE I FOUND THE TRACEME CODE
// 1.14.4 - significant change - no xtrafun needed for this now...

/* CVARS - copy and paste to shconfig.cfg

//Xavier
xavier_level 7
xavier_traillength 25			//Length of trail behind players
xavier_showteam 0				//Show trails on your team
xavier_showenemy 1				//Show trails on enemies
xavier_refreshtimer 5.0			//How often do the trails refresh

*/

#include <amxmodx>
#include <cstrike>
#include <shero>

// GLOBAL VARIABLES
new g_heroName[]="Xavier"
new g_heroID
new bool:g_hasXavier[SH_MAXSLOTS+1]
new g_spriteTrail
//----------------------------------------------------------------------------------------------
public plugin_init()
{
	// Plugin Info
	register_plugin("SUPERHERO Xavier", "2.0", "{HOJ} Batman")

	// DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
	register_cvar("xavier_level", "7")
	register_cvar("xavier_traillength", "25")
	register_cvar("xavier_showteam", "0")
	register_cvar("xavier_showenemy", "1")
	register_cvar("xavier_refreshtimer", "5.0")

	// FIRE THE EVENT TO CREATE THIS SUPERHERO!
	g_heroID = sh_create_hero(g_heroName)
	sh_hero_info(g_heroID, "Team Detection", "Detect what team a player is on by a glowing trail")
	sh_hero_bind(g_heroID, false)
	sh_hero_level(g_heroID, get_cvar_num("xavier_level"))

	// REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
	// DEATH
	register_event("DeathMsg", "xavier_death", "a")
}
//----------------------------------------------------------------------------------------------
public plugin_precache()
{
	g_spriteTrail = precache_model("sprites/laserbeam.spr")
}
//----------------------------------------------------------------------------------------------
public sh_hero_init(id, heroID, mode)
{
	// See if this hero is the same that's being init
	if ( g_heroID == heroID )
	{
		//Clear out any stale tasks
		remove_task(id)

		switch(mode)
		{
			case HERO_ADD:
			{
				g_hasXavier[id] = true
				addAllMarks(id)
				set_task(get_cvar_float("xavier_refreshtimer"), "addAllMarks", id, "", 0, "b")
			}
			case HERO_DROP:
			{
				g_hasXavier[id] = false
				removeAllMarks(id)
			}
		}
	}
}
//----------------------------------------------------------------------------------------------
public sh_new_spawn(id)
{
	if ( is_user_alive(id) && g_hasXavier[id] )
		addAllMarks(id)
}
//----------------------------------------------------------------------------------------------
public addAllMarks(id)
{
	if ( !is_user_alive(id) || !g_hasXavier[id] )
		return

	new players[32], num, markID
	new bool:sameTeam
	new bool:showTeam = (get_cvar_num("xavier_showteam") != 0)
	new bool:showEnemy = (get_cvar_num("xavier_showenemy") != 0)
	new CsTeams:idTeam = cs_get_user_team(id)

	// Get all alive players
	get_players(players, num, "a")

	for ( new i = 0; i < num; i++ )
	{
		markID = players[i]

		if ( markID == id )
			continue

		sameTeam = (idTeam == cs_get_user_team(markID))

		if ( (sameTeam && showTeam) || (!sameTeam && showEnemy) )
			addMark(id, markID)
	}
}
//----------------------------------------------------------------------------------------------
public addMark(id, markID)
{
	if ( !is_user_alive(markID) )
		return

	removeMark(id, markID)

	new CsTeams:markIDTeam = cs_get_user_team(markID)

	switch(markIDTeam)
	{
		case CS_TEAM_T:
			make_trail(id, markID, 255, 0, 0)
		case CS_TEAM_CT:
			make_trail(id, markID, 0, 0, 255)
	}
}
//----------------------------------------------------------------------------------------------
public make_trail(id, markID, red, green, blue)
{
	if ( id == markID || !is_user_alive(id) )
		return

	// Create a beam trail
	message_begin(MSG_ONE_UNRELIABLE, SVC_TEMPENTITY, {0,0,0}, id)
	write_byte(22)		// TE_BEAMENTS
	write_short(markID)
	write_short(g_spriteTrail)
	write_byte(get_cvar_num("xavier_traillength"))	//length
	write_byte(8)		//width
	write_byte(red)	//red
	write_byte(green)	//green
	write_byte(blue)	//blue
	write_byte(150)	//bright
	message_end()
}
//----------------------------------------------------------------------------------------------
public removeAllMarks(id)
{
	if ( !is_user_connected(id) || !g_hasXavier[id] )
		return

	new players[32], num, markedID

	get_players(players, num, "a")

	for ( new i = 0; i < num; i++ )
	{
		markedID = players[i]

		if ( markedID == id )
			continue

		removeMark(id, markedID)
	}
}
//----------------------------------------------------------------------------------------------
public removeMark(id, markedID)
{
	if ( !is_user_connected(id) )
		return

	// Remove trails
	message_begin(MSG_ONE_UNRELIABLE, SVC_TEMPENTITY, {0,0,0}, id)
	write_byte(99)		//TE_KILLBEAM
	write_short(markedID)
	message_end()
}
//----------------------------------------------------------------------------------------------
public xavier_death()
{
	if ( !sh_server_info(SH_MODACTIVE) )
		return

	new id = read_data(2)

	removeAllMarks(id)
}
//----------------------------------------------------------------------------------------------
public client_disconnect(id)
{
	// Stupid check but lets see
	if ( id <= 0 || id > SH_MAXSLOTS )
		return

	// Yeah don't want any left over residuals
	remove_task(id)
}
//----------------------------------------------------------------------------------------------